<template>
  <div
    class="partInfo"
    :class="{ '-active': activeElement, '-outdated': isOutdated(entity), '-not-interacted': !interacted }"
    @click="onClick">
    <slot name="control"/>
    <div class="partInfo-grid">

      <div class="area-top">
        <!--актуальность - дата добавления-->
        <div
          v-if="!isOutdated(entity)"
          class="__gray">
          {{ entity.created_at | dateFormat({ nouns: true }) | capitalize }}
        </div>
        <div
          v-else
          class="sellerOutdated">
          <img
            svg-inline
            src="~/assets/svg/redesign/outdated.svg">
          Данные не обновлялись более 14 дней
        </div>

        <!--наличие у продавца-->
        <AppSellerQuantity
          :in-stock="entity.in_stock"
          :quantity="entity.quantity"
          :under-order="entity.delivery_string"/>

      </div>

      <div class="sellerNames area-names">
        <div class="sellerNames-black">
          {{ entity.brand }}, {{ entity.vendor_code }}
        </div>
        <div class="sellerNames-gray">
          {{ entity.part_name }}
        </div>
      </div>

      <AppSellerPrice
        class="area-price"
        :discount="entity.discount_check"
        :price="entity.price"
        :old-price="entity.old_price"
        :is-wholesale="entity.is_wholesale"/>

      <div
        v-if="entity.additional_contacts"
        class="sellerContacts area-scl">
        <AppSocial
          class="_entity-offer"
          :contacts="entity.additional_contacts"
          @clicked="onClickedByMessengers(entity)"/>
      </div>

      <div class="sellerBasic area-basic">
        <div class="sellerBasic-item">
          <AppRating
            :current-rating="entity.avg_rating"
            :size="12"/>
          <span class="sellerBasic-reviews">
            <template v-if="entity.feedback_count">
              {{ entity.feedback_count }}
              {{ entity.feedback_count | transChoose(['отзыв', 'отзыва', 'отзывов']) }}
            </template>
          </span>
        </div>
        <div class="sellerBasic-item">
          <div class="sellerBasic-item-shadow __hide-shadow">
            <flink
              :href="`/seller/${entity.shop_id}/${entity.organization_id}#${entity.part_id}`"
              target="_blank"
              @click.native="goToSellerPage(entity)"
              class="sellerBasic-name">
              <img
                v-if="entity.contact_is_confirmed"
                svg-inline
                src="~/assets/svg/redesign/ok-small-blue.svg">
              <span class="link __no-wrap">
                {{ entity.shop_name }}
              </span>
            </flink>
          </div>
        </div>
        <div class="sellerBasic-item">
          <div class="sellerBasic-address">
            <span class="__medium">{{ entity.city_name }}</span>,
            {{ getAddressByPart(entity) }}
          </div>
        </div>
      </div>

      <div class="area-chat">
        <AppWidgetChat
          v-if="!isSameUser(entity)"
          :id="entity.shop_id"
          :is-full="false"
          type="shop"
          @click.native="onClickChat(entity)"/>
      </div>

      <div class="sellerOrder area-order">
        <AppWidgetChat
          v-if="!isSameUser(entity)"
          :is-full="false"
          :id="entity.shop_id"
          type="shop"
          @click.native="onClickChat(entity)"/>
        <AppButton
          @click.native="onFastOrder(entity); $ym('to_order');$ga('Country1','Click32')"
          :classes="['buttonOrder']">
          <template #button-item>Быстрый заказ</template>
        </AppButton>
        <!--        TODO: нет страницы Корзина-->
        <!--        <AppAddCartControl :entity="entity"/>-->
      </div>
    </div>
  </div>
</template>

<script>
// import { isEmpty } from 'lodash-es';
import { mapMutations, createNamespacedHelpers } from 'vuex';
import { SET_FAST_ORDER } from '~/assets/js/store/root/mutation-types';
import { SHOW_FAST_ORDER_MODAL } from '~/assets/js/store/actionManager/mutation-types';
import Item from '~/assets/js/model/item/item';

import AppButton from '~/components/redesign/app-buttons/app-button';
import AppRating from '~/components/redesign/app-rating';
import AppWidgetChat from '~/components/redesign/widget/app-widget-chat';
import AppSocial from '~/components/redesign/app-social';
import AppSellerPrice from '~/components/redesign/seller/app-seller-price';
import AppSellerQuantity from '~/components/redesign/seller/app-seller-quantity';
import AppAddCartControl from '~/components/redesign/app-cart/app-add-cart-control';

const STORE_ACTION_MANAGER = createNamespacedHelpers('actionManager');

export default {
  name: 'AppEntityOffer',
  components: {
    AppSellerQuantity,
    AppSellerPrice,
    AppSocial,
    AppWidgetChat,
    AppRating,
    AppButton,
    AppAddCartControl,
  },
  props: {
    entity: {
      type: Object,
      default() { return {}; },
    },
    activeElement: {
      type: Boolean,
      default: false,
    },
    index: {
      type: Number,
      default: null,
    },
    interacted: {
      type: Boolean,
      default: false,
    },
  },
  methods: {
    ...mapMutations({
      setFastOrder: SET_FAST_ORDER,
    }),
    ...STORE_ACTION_MANAGER.mapMutations({
      showFastOrderModal: SHOW_FAST_ORDER_MODAL,
    }),
    onFastOrder(entity) {
      this.setFastOrder(entity);
      this.showFastOrderModal();
    },
    isOutdated(part) {
      return Item.isOutdated(new Item(part), this.$config.itemOutdatedTreshold);
    },
    isSameUser(part) {
      return Item.isOwnedByUser(this.auth && this.auth.id, new Item(part));
    },
    onClick() {
      this.$emit('select-entity', this.index);
    },
    onClickChat(part) {
      this.$statPpn('click-chat', this.getStatData(part));
    },
    onClickedByMessengers(part) {
      this.$statPpn('view-messenger', this.getStatData(part));
    },
    getAddressByPart(part) {
      const result = [];

      if (part.isNetShop) {
        result.push('интернет магазин');
      } else {
        if (part.street) {
          result.push(part.street);
        }
        if (part.building) {
          result.push(part.building);
        }
        if (part.office) {
          result.push(`офис ${part.office}`);
        }
      }
      return result.join(', ');
    },
    goToSellerPage(part) {
      const data = this.getStatData(part);
      window.sessionStorage.setItem(`part${part.part_id}`, JSON.stringify(data));
      this.$statPpn('view-shop-card', data);
    },
    getStatData(part) {
      return {
        shopId: part.shop_id,
        brandId: part.part_manufacturer_id,
        partId: part.part_id,
        itemId: part.item_id,
        itemName: part.item_name,
        brandName: part.brand,
        partNumber: part.vendor_code,
        partName: part.part_name,
      };
    },
  },
};
</script>

<style scoped lang="postcss">
  /* Стили для блоков с инфой о продавце */
  @import '~/assets/css/components/seller-info.css';

  .partInfo {
    display: block;
    padding: 1rem;
    max-width: 100%;
    background-color: var(--bg-main);
    border-bottom: 1px solid var(--color-disabled);

    &-grid {
      display: grid;
      max-width: 100%;

      .area-top {
        grid-area: top;
      }
      .area-chat {
        grid-area: chat;
      }
      .area-names {
        grid-area: names;
      }
      .area-price {
        grid-area: price;
        margin-left: auto;
        margin-bottom: 0.375rem;
      }
      .area-scl {
        grid-area: scl;
        margin-left: auto;
      }
      .area-basic {
        grid-area: basic;
      }
      .area-order {
        grid-area: order;
        margin-left: auto;
      }
    }

    &.-outdated {
      background-color: var(--bg-lightest);

      .__hide-shadow:after {
        background-image: linear-gradient(to left, var(--bg-lightest) 0.5rem, var(--bg-transparent));
      }

      .area-top {
        flex-direction: column;

        .sellerOutdated {
          padding-bottom: 0.875rem;
        }
      }
    }

    &.-active:not(.-not-interacted) {
      background-color: var(--bg-light-blue);

      .__hide-shadow:after {
        background-image: linear-gradient(to left, var(--bg-light-blue) 0.5rem, var(--bg-transparent));
      }
    }

    @media screen and (min-width: 981px) {
      &-grid {
        grid-template-columns: 50% 50%;
        grid-template-areas:
          "names price"
          "basic order"
          "basic scl";

        .sellerBasic-address,
        .area-top,
        .area-chat {
          display: none;
        }

        .sclContacts {
          margin: 0.5rem 0 0;
        }

        .appWidgetChat {
          margin-right: 1rem;
        }
      }
    }

     @media screen and (min-width: 981px) and (max-width: 1024px) {
       &.-single {
        position: fixed;
        z-index: 1;
        bottom: 0;
        left: 0;
        width: 100vw;
        min-width: 20rem;

        .appWidgetChat {
          margin-bottom: 1rem;
          margin-right: 0;
        }

        .buttonClose {
          display: flex;
          justify-content: center;
          align-items: center;
          margin: -0.75rem -1.25rem 0.5rem auto;
          width: 3.75rem;
          height: 2.25rem;
          background: none;
          border: none;
          outline: none;
          .svg {
            width: 1.25rem;
            height: auto;
            fill: var(--fill-light);
          }
        }
      }
     }

    @media screen and (max-width: 980px) {
      padding: 1.25rem;

      &-grid {
        grid-template-columns: minmax(50%, 80%) 4.75rem;
        grid-template-areas:
          "top top"
          "names names"
          "price price"
          "basic chat"
          "scl scl"
          "order order";

        .area-price, .area-scl, .area-order {
          margin-left: 0;
        }

        .area-top {
          display: flex;
          justify-content: flex-start;
          padding-bottom: 0.75rem;
          font-size: 0.875rem;

          .sellerQuantity {
            margin-left: auto;
          }
        }

        .sellerBasic {
          padding-bottom: 0;

          &-address {
            padding-bottom: .5rem;
          }
        }

        .sellerContacts {
          justify-content: flex-start;
        }

        .appWidgetChat {
          margin-left: 1rem;
        }

        .sellerOrder {
          padding-top: 1rem;

          .appWidgetChat {
            display: none;
          }
        }
      }

      &.-single {
        position: fixed;
        z-index: 1;
        bottom: 0;
        left: 0;
        width: 100vw;
        min-width: 20rem;

        .buttonClose {
          display: flex;
          justify-content: center;
          align-items: center;
          margin: -0.75rem -1.25rem 0.5rem auto;
          width: 3.75rem;
          height: 2.25rem;
          background: none;
          border: none;
          outline: none;
          .svg {
            width: 1.25rem;
            height: auto;
            fill: var(--fill-light);
          }
        }
      }
    }
  }
</style>
